SystemOrganization addCategory: #'CodeModel-Iterators'!
SystemOrganization addCategory: #'CodeModel-Model'!
SystemOrganization addCategory: #'CodeModel-Parser'!
SystemOrganization addCategory: #'CodeModel-Tests'!
SystemOrganization addCategory: #'CodeModel-Utilities'!

SmaCCParser subclass: #CMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 09:54'!
methodSeqWithTemps: nodes
	"Annotations | TemporaryVariables | Annotations Statements"

	^ Array
		with: nodes first, nodes fifth
		with: (self sequenceWithTemps: {{nodes second. nodes third. nodes fourth}. nodes sixth})
! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
value: nodes

	^ nodes first value! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litChar: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: (nodes first value at: 2)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:08'!
firstIn: nodes
	^ OrderedCollection with: nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:49'!
method: nodes
	^ CMMethod
		selectorParts: (nodes first first collect: [:ea | ea asTreeToken])
		arguments: nodes first second
		annotations: nodes second first
		body: nodes second second! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 5/30/2004 00:12'!
parserDefinitionComment

	"%id <name> <negativeNumber> <binarySymbol>;
%start MethodPattern Sequence Annotations;

Method:
	MethodPattern MethodSequence				{#method:};

MethodPattern:
	<name>										{#unaryMethodPattern:}
|	<binarySymbol> Argument 					{#twoArrays:}
|	KeywordMethodPattern 						{#first:};

KeywordMethodPattern:
	<keyword> Argument							{#messagePart:}
|	KeywordMethodPattern <keyword> Argument	{#addMessagePart:};

MethodSequence:
	Annotations Statements						{#methodSequence:}
|	Annotations ""||"" Annotations Statements		{#methodSeqEmptyTemps:}
|	Annotations ""|"" TemporaryVariables ""|"" Annotations Statements {#methodSeqWithTemps:};

Annotations:
												{#empty}
|	Annotations ""<"" KeywordMessage "">""			{#addAnnotation:}
|	Annotations ""<"" KeywordMessage ""><"" KeywordMessage "">"" {#doubleAnnotation:};
	
Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											
|	""|"" TemporaryVariables ""|"";

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												
|	StatementList "".""?							
|	StatementList ""."" ""^"" Expression "".""?			{#returnAdd:}
|	""^"" Expression "".""?							{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList ""."" Expression					{#expressionAdd:};

Block:
	""["" BlockArgs ""|"" Sequence ""]""					{#blockWithArgs:}
|	""["" Sequence ""]""								{#blockNoArgs:}
|	""["" BlockArgs ""]""								{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {#blockWithTemps:};

BlockArgs:
	"":"" Argument								{#colonAdd:}
|	BlockArgs "":"" Argument						{#argumentAdd:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression "")""								{#parenthesize:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:};

Cascade:
	MessageSend								{#first:}
|	Cascade "";"" Message							{#cascade:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:};

BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements ""}""								{#array:};

Variable: 
	<name>										{#variable:};

Argument:
	<name>										{#argument:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|	""#"" ""["" ByteArray ""]""							{#litArray:}
|	""#"" ""("" LiteralArray "")""						{#litArray:};

ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray "")""							{#contents2:}
|	""["" ByteArray ""]""							{#contents2:}
|	<anyChar>									{#valueSymbol:};

"! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/30/2004 00:12'!
startingStateForMethod
	^1! !

!CMParser class methodsFor: 'generated-accessing' stamp: 'cwp 5/30/2004 00:12'!
scannerClass
	^CMScanner! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:41'!
blockWithArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: nodes fourth)
			leftBracket: nodes first asTreeToken
			rightBracket: nodes fifth asTreeToken;
			bar: nodes third! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/30/2004 00:12'!
startingStateForMethodPattern
	^2! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:38'!
expressionAdd: nodes
	| tokens |
	tokens _ nodes first.
	tokens 
		add: nodes second;
		add: nodes third.
	^ tokens! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:44'!
colonAdd: nodes
	nodes second colon: nodes first asTreeToken.
	^ OrderedCollection with: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litFalse: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: false! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:50'!
sequence: nodes
	^ self 
		divideStatements: nodes first
		in: [:s :p | CMSequence statements: s periods: p]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
assignment: nodes

	^ CMAssignment
		variable: nodes first 
		operator: nodes second asTreeToken
		value: nodes third ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 14:36'!
unaryMethodPattern: nodes
	^ Array 
		with: (Array with: nodes first)
		with: #()
		! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 15:39'!
parenthesize: nodes
	nodes second leftParen: nodes first rightParen: nodes third.
	^ nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:51'!
variable: nodes

	^ CMVariableReference new
		identifier: nodes first asTreeToken ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
unaryMessage: nodes

	^ {{nodes first}. #()}! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 5/30/2004 00:12'!
symbolComment

	"
1. "".""
2. ""^""
3. ""#""
4. "">""
5. ""[""
6. ""||""
7. ""|""
8. ""><""
9. ""]""
10. ""<""
11. ""true""
12. ""false""
13. "":""
14. ""}""
15. ""nil""
16. ""{""
17. ""(""
18. "")""
19. "";""
20. <number>
21. <negativeNumber>
22. <string>
23. <name>
24. <keyword>
25. <multikeyword>
26. <binarySymbol>
27. <assignment>
28. <alternateKeyword>
29. <whitespace>
30. <comment>
31. <character>
32. <anyChar>
33. TemporaryVariables
34. KeywordMessage
35. B e g i n
36. Variable
37. StatementList
38. Optional: "".""
39. Expression
40. BlockArgs
41. Block
42. Assignment
43. Cascade
44. Primary
45. Array
46. Literal
47. Statements
48. MessageSend
49. Message
50. KeywordMessageSend
51. BinaryMessageSend
52. UnaryMessageSend
53. UnaryMessage
54. BinaryMessage
55. KeywordArgument
56. BinaryArgument
57. MethodSequence
58. Argument
59. Annotations
60. Sequence
61. MethodPattern
62. ByteArray
63. LiteralArray
64. ArrayLiteral
65. Method
66. E O F
67. error
68. KeywordMethodPattern
69. Temporaries
"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
addMessagePart: nodes

	^ {nodes first first copyWith: nodes second.
	   nodes first second copyWith: nodes third}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
streamPut: nodes

	^ nodes first
		nextPut: nodes second;
		yourself! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:47'!
doubleAnnotation: nodes
	"Annotations < KeywordMessage >	< KeywordMessage >"
		
	| result |
	result _ self addAnnotation: {nodes first. nodes second. nodes third. nodes fourth firstChar}.
	^ self addAnnotation: {result. nodes fourth secondChar. nodes fifth. nodes sixth}.
	
	! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:38'!
argumentAdd: nodes
	| arguments |
	arguments _ nodes first.
	arguments add: nodes third.
	arguments last colon: nodes second.
	^ arguments! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 21:59'!
twoArrays: nodes

	^ Array
		with: (Array with: nodes first)
		with: (Array with: nodes second)
! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:39'!
array: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMArray statements: s periods: p)
						leftBrace: nodes first asTreeToken
						rightBrace: nodes third asTreeToken]! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 5/30/2004 00:12'!
transitionTable
	^#(
#(3 21 23 25 24 29 26 33 61 37 65 41 68)
#(3 21 23 25 24 29 26 45 61 41 68)
#(3 49 2 53 3 57 5 61 6 65 7 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 165 60 178 66 169 69)
#(3 294 10 173 59 294 66)
#(2 314 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 66)
#(3 177 23 181 58)
#(3 177 23 185 58)
#(3 294 2 294 3 294 5 294 6 294 7 294 10 294 11 294 12 294 15 294 16 294 17 294 20 294 21 294 22 294 23 294 31 189 57 193 59 294 66)
#(2 0 66)
#(3 322 2 322 3 322 5 322 6 322 7 322 10 322 11 322 12 322 15 322 16 322 17 322 20 322 21 322 22 322 23 197 24 322 31 322 66)
#(2 0 66)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 201 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52)
#(3 205 5 209 17 213 22 217 23 221 24 225 25 229 26 233 28)
#(3 49 2 53 3 57 5 61 6 65 7 178 9 69 11 73 12 237 13 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 241 40 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 245 60 169 69)
#(2 390 2 3 5 9 11 12 15 16 17 20 21 22 23 31 66)
#(3 6 7 6 23 249 33)
#(2 118 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 122 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 126 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(3 49 2 53 3 57 5 69 11 73 12 178 14 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 253 47 149 48 153 50 157 51 161 52)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 257 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52)
#(2 130 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 134 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 142 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 26 1 4 7 8 9 14 18 19 23 24 26 27 66)
#(2 138 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(3 110 1 110 9 110 14 110 18 110 23 110 24 110 26 261 27 110 66)
#(3 265 1 38 9 38 14 269 38 38 66)
#(2 30 1 9 14 66)
#(2 102 1 4 8 9 14 18 19 23 24 26 66)
#(2 46 1 9 14 18 66)
#(3 50 1 50 9 50 14 50 18 273 19 50 66)
#(3 54 1 54 9 54 14 54 18 277 23 281 24 285 26 289 34 293 53 297 54 54 66)
#(2 98 1 4 8 9 14 18 19 23 24 26 66)
#(2 106 1 4 8 9 14 18 19 23 24 26 66)
#(2 306 9 66)
#(2 86 1 9 14 18 19 66)
#(2 194 1 9 14 18 19 66)
#(3 198 1 198 9 198 14 198 18 198 19 281 24 285 26 301 34 305 54 198 66)
#(3 202 1 202 9 202 14 202 18 202 19 277 23 281 24 285 26 309 34 313 53 317 54 202 66)
#(2 0 66)
#(3 49 2 53 3 57 5 178 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 321 47 149 48 153 50 157 51 161 52 178 66)
#(3 325 10 0 66)
#(2 290 2 3 5 6 7 9 10 11 12 13 15 16 17 20 21 22 23 24 31 66)
#(2 382 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 24 31 66)
#(2 318 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 66)
#(2 378 66)
#(3 49 2 53 3 57 5 329 6 333 7 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 337 47 149 48 153 50 157 51 161 52 178 66)
#(3 177 23 341 58)
#(3 345 1 38 9 38 14 349 38 38 66)
#(3 326 9 326 20 353 62)
#(3 334 3 334 5 334 11 334 12 334 15 334 17 334 18 334 20 334 21 334 22 334 23 334 24 334 25 334 26 334 28 334 31 334 32 357 63)
#(2 146 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 150 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 158 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 162 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 154 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 166 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(3 177 23 361 58)
#(3 365 6 369 7 373 9 377 13)
#(2 381 9)
#(3 385 7 101 23 389 36)
#(2 393 14)
#(2 397 18)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 401 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52)
#(3 405 2 53 3 57 5 42 9 69 11 73 12 42 14 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 409 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52 42 66)
#(2 182 9 14 66)
#(3 277 23 281 24 285 26 413 34 417 49 421 53 425 54)
#(2 250 1 4 8 9 14 18 19 23 24 26 66)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 429 36 121 41 433 44 137 45 141 46 437 51 441 52 445 55)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 429 36 121 41 449 44 137 45 141 46 453 52 457 56)
#(3 226 1 226 9 226 14 226 18 226 19 461 24 226 66)
#(2 246 1 4 8 9 14 18 19 23 24 26 66)
#(2 238 1 4 8 9 14 18 19 24 26 66)
#(3 218 1 218 9 218 14 218 18 218 19 461 24 218 66)
#(2 230 1 4 8 9 14 18 19 24 26 66)
#(3 222 1 222 9 222 14 222 18 222 19 461 24 222 66)
#(2 242 1 4 8 9 14 18 19 23 24 26 66)
#(2 234 1 4 8 9 14 18 19 24 26 66)
#(2 310 9 66)
#(3 281 24 465 34)
#(3 294 2 294 3 294 5 294 10 294 11 294 12 294 15 294 16 294 17 294 20 294 21 294 22 294 23 294 31 469 59 294 66)
#(3 6 7 6 23 473 33)
#(2 278 66)
#(2 386 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 24 31 66)
#(2 42 9 14 66)
#(2 190 9 14 66)
#(3 477 9 481 20)
#(3 53 3 485 5 69 11 73 12 77 15 489 17 493 18 89 20 93 21 97 22 497 23 501 24 505 25 509 26 513 28 105 31 517 32 521 46 525 64)
#(2 58 6 7 9 13)
#(3 6 7 6 23 529 33)
#(3 49 2 53 3 57 5 61 6 65 7 178 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 50 157 51 161 52 533 60 169 69)
#(2 74 1 4 8 9 14 18 19 23 24 26 66)
#(3 177 23 537 58)
#(2 70 1 4 8 9 14 18 19 23 24 26 66)
#(2 394 2 3 5 9 11 12 15 16 17 20 21 22 23 31 66)
#(2 10 7 23)
#(2 114 1 4 8 9 14 18 19 23 24 26 66)
#(2 94 1 4 8 9 14 18 19 23 24 26 66)
#(2 82 1 9 14 18 66)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 541 39 121 41 125 42 129 43 133 44 137 45 141 46 149 48 153 50 157 51 161 52)
#(2 34 1 9 14 66)
#(3 214 1 214 9 214 14 214 18 214 19 461 24 214 66)
#(2 90 1 9 14 18 19 66)
#(2 206 1 9 14 18 19 66)
#(2 210 1 9 14 18 19 66)
#(2 110 1 4 8 9 14 18 19 23 24 26 66)
#(3 266 1 266 4 266 8 266 9 266 14 266 18 266 19 277 23 266 24 285 26 293 53 297 54 266 66)
#(3 258 1 258 4 258 8 258 9 258 14 258 18 258 19 258 24 285 26 305 54 258 66)
#(3 262 1 262 4 262 8 262 9 262 14 262 18 262 19 277 23 262 24 285 26 313 53 317 54 262 66)
#(2 14 1 4 8 9 14 18 19 24 66)
#(3 274 1 274 4 274 8 274 9 274 14 274 18 274 19 277 23 274 24 274 26 293 53 274 66)
#(3 270 1 270 4 270 8 270 9 270 14 270 18 270 19 277 23 270 24 270 26 313 53 270 66)
#(2 254 1 4 8 9 14 18 19 24 26 66)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 429 36 121 41 433 44 137 45 141 46 437 51 441 52 545 55)
#(3 549 4 553 8 461 24)
#(3 49 2 53 3 57 5 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 557 47 149 48 153 50 157 51 161 52 178 66)
#(3 561 7 101 23 389 36)
#(2 170 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 330 9 20)
#(3 326 9 326 20 565 62)
#(3 334 3 334 5 334 11 334 12 334 15 334 17 334 18 334 20 334 21 334 22 334 23 334 24 334 25 334 26 334 28 334 31 334 32 569 63)
#(2 174 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 32 66)
#(2 346 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 354 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 358 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 350 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 362 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 374 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 342 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 338 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(3 573 7 101 23 389 36)
#(2 577 9)
#(2 62 6 7 9 13)
#(3 345 1 38 9 38 14 581 38 38 66)
#(2 18 1 4 8 9 14 18 19 24 66)
#(2 298 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 66)
#(3 281 24 585 34)
#(2 282 66)
#(3 294 2 294 3 294 5 294 10 294 11 294 12 294 15 294 16 294 17 294 20 294 21 294 22 294 23 294 31 589 59 294 66)
#(3 593 9 481 20)
#(3 53 3 485 5 69 11 73 12 77 15 489 17 597 18 89 20 93 21 97 22 497 23 501 24 505 25 509 26 513 28 105 31 517 32 521 46 525 64)
#(3 49 2 53 3 57 5 178 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 601 47 149 48 153 50 157 51 161 52)
#(2 66 1 4 8 9 14 18 19 23 24 26 66)
#(2 186 9 14 66)
#(3 605 4 461 24)
#(3 49 2 53 3 57 5 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 36 113 37 117 39 121 41 125 42 129 43 133 44 137 45 141 46 609 47 149 48 153 50 157 51 161 52 178 66)
#(2 370 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 366 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 32)
#(2 613 9)
#(2 302 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 66)
#(2 286 66)
#(2 78 1 4 8 9 14 18 19 23 24 26 66)
)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:38'!
argument: nodes
	^ CMArgument identifier: nodes first asTreeToken! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 5/30/2004 00:12'!
reduceTable
	^#(
#(33 0 #array)
#(33 2 #add:)
#(34 2 #messagePart:)
#(34 3 #addMessagePart:)
#(35 1 #reduceFor:)
#(36 1 #variable:)
#(37 1 #firstIn:)
#(37 3 #expressionAdd:)
#(38 0 #reduceActionForOptionalXXXXX1:)
#(38 1 #reduceActionForOptionalXXXXX2:)
#(39 1 #first:)
#(39 1 #first:)
#(39 1 #first:)
#(40 2 #colonAdd:)
#(40 3 #argumentAdd:)
#(41 5 #blockWithArgs:)
#(41 3 #blockNoArgs:)
#(41 3 #blockArgs:)
#(41 7 #blockWithTemps:)
#(42 3 #assignment:)
#(43 1 #first:)
#(43 3 #cascade:)
#(44 3 #parenthesize:)
#(44 1 #first:)
#(44 1 #first:)
#(44 1 #first:)
#(44 1 #first:)
#(45 3 #array:)
#(46 1 #litTrue:)
#(46 1 #litFalse:)
#(46 1 #litNil:)
#(46 1 #litNumber:)
#(46 1 #litNumber:)
#(46 1 #litChar:)
#(46 1 #litString:)
#(46 2 #litStringSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 2 #litSymbol:)
#(46 4 #litArray:)
#(46 4 #litArray:)
#(47 0 #reduceFor:)
#(47 2 #reduceFor:)
#(47 5 #returnAdd:)
#(47 3 #return:)
#(48 1 #first:)
#(48 1 #first:)
#(48 1 #first:)
#(49 1 #first:)
#(49 1 #first:)
#(49 1 #first:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(52 2 #messageSend:)
#(52 2 #messageSend:)
#(53 1 #unaryMessage:)
#(54 2 #messagePart:)
#(55 1 #first:)
#(55 1 #first:)
#(55 1 #first:)
#(56 1 #first:)
#(56 1 #first:)
#(57 2 #methodSequence:)
#(57 4 #methodSeqEmptyTemps:)
#(57 6 #methodSeqWithTemps:)
#(58 1 #argument:)
#(59 0 #empty)
#(59 4 #addAnnotation:)
#(59 6 #doubleAnnotation:)
#(60 1 #sequence:)
#(60 2 #sequenceWithTemps:)
#(61 1 #unaryMethodPattern:)
#(61 2 #twoArrays:)
#(61 1 #first:)
#(62 0 #byteStream)
#(62 2 #byteStreamPut:)
#(63 0 #stream)
#(63 2 #streamPut:)
#(64 1 #value:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 1 #valueSymbol:)
#(64 3 #contents2:)
#(64 3 #contents2:)
#(64 1 #valueSymbol:)
#(65 2 #method:)
#(68 2 #messagePart:)
#(68 3 #addMessagePart:)
#(69 1 #reduceFor:)
#(69 3 #reduceFor:)
)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:38'!
addAnnotation: nodes
	"Annotations < KeywordMessage >	"
		
	 nodes first add: ((CMAnnotation 
						selectorParts: (nodes third first collect: [:ea | ea asTreeToken]) 
						arguments: nodes third second)
							leftParen: nodes second asTreeToken
							rightParen: nodes fourth asTreeToken).
	^ nodes first

			! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
array

	^ #()! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litNil: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: nil! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litSymbol: nodes

	^ CMLiteral
		token: nodes second asTreeToken
		value: nodes second value asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
return: nodes
	| statement |
	statement _ Array new: nodes size - 1.
	statement at: 1 put: (CMReturn return: nodes first asTreeToken  value: nodes second).
	nodes size = 3 ifTrue: [statement at: 2 put: nodes third].
	^ statement! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
messagePart: nodes

	^ {{nodes first}. {nodes second}}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
returnAdd: nodes
	| statements |
	statements _ nodes first.
	statements add: nodes second.
	statements add: (CMReturn return: nodes third asTreeToken value: nodes fourth).
	nodes size > 4 ifTrue: [statements add: nodes fifth].
	^ statements! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 14:46'!
empty
	^ OrderedCollection new! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
blockArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: (CMSequence statements: #() periods: #()))
					leftBracket: nodes first asTreeToken
					rightBracket: nodes third asTreeToken! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litString: nodes

	| s |
	s _ nodes first value.
	^ CMLiteral
		token: nodes first asTreeToken
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''')! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStream

	^ ByteArray new writeStream! !

!CMParser methodsFor: 'parsing' stamp: 'cwp 5/29/2004 11:35'!
actionForCurrentToken
	| ids action |
	ids := currentToken id.
	1 to: ids size
		do: 
			[:i | 
			action := self actionFor: (ids at: i).
			(action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
			(ids at: i) = scanner negativeNumberId 
				ifTrue: 
					[currentToken := CMParseToken 
										id: (Array with: scanner binarySymbolId)
										whitespace: currentToken whitespace
										start: currentToken startPosition
										value: '-'.
					scanner position: currentToken stopPosition - 1.
					^self actionForCurrentToken]].
	^self errorAction! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:44'!
cascade: nodes
	| cascade |
	(nodes first isKindOf: CMMessage)
		ifTrue: [cascade _ (CMCascade message: nodes first)]
		ifFalse: [cascade _ nodes first].
	cascade
		addMessage: (CMMessage
						receiver: cascade messages first receiver
						selectorParts: (nodes third first collect: [:ea | ea asTreeToken])
						arguments: nodes third last)
		semicolon: nodes second asTreeToken.
	^ cascade! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
add: nodes

	^ nodes first copyWith: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
sequenceWithTemps: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMSequence temporaries: nodes first second statements: s periods: p)
						leftBar: nodes first first asTreeToken 
						rightBar: nodes first third asTreeToken]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:45'!
litArray: nodes
	| token |
	token _ String streamContents: [:stream |
						stream 
							nextPutAll: nodes first value;
							nextPutAll: nodes second value.
						nodes third contents do: [:ea | stream nextPutAll: ea asString]
											separatedBy: [stream nextPut: $ ].
						stream nextPutAll: nodes fourth value].				
	^ CMLiteral
		token: (CMToken whitespace: nodes first whitespace value: token)
		value: nodes third contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
contents2: nodes

	^ nodes second contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:48'!
litTrue: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: true! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStreamPut: nodes

	^ nodes first
		nextPut: nodes second value asNumber;
		yourself! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litStringSymbol: nodes

	| s |
	s _ nodes second value.
	^ CMLiteral
		token: nodes second asTreeToken
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''') asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:41'!
blockWithTemps: nodes
	"This production rule ensures that '[:arg || temp | statement]' will parse correctly. It's
	necessary because the scanner treats the '||' as a single token - necessary for binary
	selectors. So here we manually split it up into two tokens, and pass the nodes along
	to the ordinary production rules."
	
	| left right subset body |
	left _ nodes third firstChar.
	right _ nodes third secondChar.
	
	"create the node structure that #sequenceWithTemps expects"
	subset _ OrderedCollection new.
	subset 
		add: right;
		add: nodes fourth;
		add: nodes fifth.
	subset _ OrderedCollection with: subset.
	subset add: nodes sixth.
	body _ self sequenceWithTemps: subset.
	
	"create the node structure that #blockWithArgs: expects"
	subset _ nodes first: 2.
	subset 
		add: left;
		add: body;
		add: nodes seventh.
	
	^ self blockWithArgs: subset
! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/30/2004 00:12'!
startingStateForAnnotations
	^4! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/24/2004 13:46'!
parseExpression: aString
	^ self parse: aString startingAt: self startingStateForSequence! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:16'!
methodSequence: nodes
	nodes at: 2 put: (self 
						divideStatements: nodes second 
						in: [:s :p | CMSequence statements: s periods: p]).
	^ nodes! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/23/2004 22:44'!
parseMethod: aString
	^ self parse: aString startingAt: self startingStateForMethod ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:49'!
primitiveMessage: nodes
	^ (CMAnnotation 
		selectorParts: (nodes second first collect: [:ea | ea asTreeToken])
		arguments: nodes second second)
			leftParen: nodes first rightParen: nodes third! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 5/30/2004 00:12'!
reduceActionForOptionalXXXXX2: nodes 
	^nodes at: 1! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/26/2004 11:53'!
parseAnnotations: aString
	^ self parse: aString startingAt: self startingStateForAnnotations! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
blockNoArgs: nodes

	^ (CMBlock
		body: nodes second)
			leftBracket: nodes first asTreeToken
			rightBracket: nodes third asTreeToken
		! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
stream

	^ Array new writeStream! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litNumber: nodes

	| str num |
	str _ nodes first value readStream.
	num _ Number readFrom: str.
	str atEnd ifFalse: [
		currentToken _ nil.
		scanner position: scanner position - (str originalContents size - str position) + 1.
		self reportErrorMessage: 'Digit out of range'].
	^ CMLiteral token: nodes first asTreeToken value: num! !

!CMParser methodsFor: 'private' stamp: 'cwp 5/25/2004 11:45'!
divideStatements: aCollection in: aBlock
	| statements periods |
	statements _ OrderedCollection new.
	periods _ OrderedCollection new.
	aCollection pairsDo: [:s :p | statements add: s. p ifNotNil: [periods add: p]].
	^ aBlock value: statements value: periods
	! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:48'!
messageSend: nodes

	^ CMMessage
		receiver: nodes first
		selectorParts: (nodes second first collect: [:ea | ea asTreeToken])
		arguments: nodes second last! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 5/30/2004 00:12'!
reduceActionForOptionalXXXXX1: nodes 
	^nil! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 5/30/2004 00:12'!
startingStateForSequence
	^3! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
first: nodes

	^ nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:42'!
methodSeqEmptyTemps: nodes
	"Annotations || Annotations Statements"	

	| left right |
	left _ nodes second firstChar.
	right _ nodes second secondChar.
	
	^ self methodSeqWithTemps: {nodes first. left. OrderedCollection new. right. nodes third. nodes fourth} ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
valueSymbol: nodes

	^ nodes first value asSymbol! !

SmaCCScanner subclass: #CMScanner
	instanceVariableNames: 'whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan8
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan6
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(28).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan1
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan3
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^self scan4! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:19'!
flushWhitespace
	| answer |
	answer _ whitespace.
	whitespace _ String new.
	^ answer! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/30/2004 00:12'!
errorTokenId
	^67! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan4
	self recordMatch: #(22).
	self step.
	currentCharacter == $' ifTrue: [^self scan3].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/30/2004 00:12'!
nameId
	^23! !

!CMScanner class methodsFor: 'generated-comments' stamp: 'cwp 5/30/2004 00:12'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: = | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';')

"! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/30/2004 00:12'!
emptySymbolTokenId
	^66! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan2
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(21).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/30/2004 00:12'!
negativeNumberId
	^21! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scanForToken
	self step.
	(currentCharacter <= $ or: 
			[(currentCharacter between: $ and: $) 
				or: [currentCharacter == $` or: [currentCharacter >= $]]]) 
		ifTrue: [^self recordAndReportMatch: #(32)].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(23 32).
				self step.
				(currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(23).
						self step.
						currentCharacter isDigit or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter == $: ifTrue: [^self scan9].
						^self reportLastMatch].
				currentCharacter == $: ifTrue: [^self scan9].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[currentCharacter == $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[self recordMatch: #(20 32).
			self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. ifTrue: [^self scan8].
					currentCharacter == $e ifTrue: [^self scan1].
					currentCharacter == $r ifTrue: [^self scan7].
					^self reportLastMatch].
			currentCharacter == $. ifTrue: [^self scan8].
			currentCharacter == $e ifTrue: [^self scan1].
			currentCharacter == $r ifTrue: [^self scan7].
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[self recordMatch: #whitespace.
			self step.
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self recordMatch: #whitespace.
					self step.
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^self recordAndReportMatch: #comment].
			^self reportLastMatch].
	currentCharacter == $# ifTrue: [^self recordAndReportMatch: #(3 32)].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			^self recordAndReportMatch: #(31)].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(32).
			self step.
			currentCharacter ~~ $' ifTrue: [^self scan3].
			currentCharacter == $' ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(17 32)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(18 32)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. 
						ifTrue: 
							[self step.
							currentCharacter isDigit 
								ifTrue: 
									[
									[self recordMatch: #(21).
									self step.
									currentCharacter isDigit] 
											whileTrue.
									currentCharacter == $e ifTrue: [^self scan2].
									^self reportLastMatch].
							^self reportLastMatch].
					currentCharacter == $e ifTrue: [^self scan2].
					currentCharacter == $r 
						ifTrue: 
							[self step.
							(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(21).
									self step.
									currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter == $. 
										ifTrue: 
											[self step.
											(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
												ifTrue: 
													[
													[self recordMatch: #(21).
													self step.
													currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
															whileTrue.
													currentCharacter == $e ifTrue: [^self scan2].
													^self reportLastMatch].
											^self reportLastMatch].
									currentCharacter == $e ifTrue: [^self scan2].
									^self reportLastMatch].
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(1 32)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(13 32).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(27)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(19 32)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(10 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(4 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $= and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $< 
				ifTrue: 
					[self recordMatch: #(8 26).
					self step.
					(currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(26).
							self step.
							currentCharacter == $!! or: 
									[(currentCharacter between: $% and: $&) or: 
											[(currentCharacter between: $* and: $,) or: 
													[currentCharacter == $/ or: 
															[(currentCharacter between: $< and: $@) or: 
																	[currentCharacter == $\ 
																		or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(5 32)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(9 32)].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(2 32)].
	currentCharacter == $_ ifTrue: [^self recordAndReportMatch: #(27 32)].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(16 32)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(7 26 32).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $| 
				ifTrue: 
					[self recordMatch: #(6 26).
					self step.
					(currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(26).
							self step.
							currentCharacter == $!! or: 
									[(currentCharacter between: $% and: $&) or: 
											[(currentCharacter between: $* and: $,) or: 
													[currentCharacter == $/ or: 
															[(currentCharacter between: $< and: $@) or: 
																	[currentCharacter == $\ 
																		or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(14 32)].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan5
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(25).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:23'!
whitespace 
	whitespace := whitespace, outputStream contents.

	self resetScanner.
	self scanForToken! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/29/2004 11:38'!
scannerError
	(stream atEnd and: [start == (stream position + 1)]) 
		ifTrue: 
			[returnMatchBlock value: (CMParseToken 
										id: (Array with: self emptySymbolTokenId)
										whitespace: ''
										start: start
										value: '')].
	stream position: start - 1.
	returnMatchBlock value: (CMParseToken 
								id: #(0)
								whitespace: ''
								start: start
								value: (String with: stream next))
! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 5/30/2004 00:12'!
binarySymbolId
	^26! !

!CMScanner methodsFor: 'initialize-release' stamp: 'cwp 5/24/2004 21:15'!
initialize
	super initialize.
	whitespace _ ''! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:18'!
resetScanner
	^ super resetScanner! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan7
	self step.
	(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
					whileTrue.
			currentCharacter == $. 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
						ifTrue: 
							[
							[self recordMatch: #(20).
							self step.
							currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
									whileTrue.
							currentCharacter == $e ifTrue: [^self scan1].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner class methodsFor: 'generated-initialization' stamp: 'cwp 5/30/2004 00:12'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(23 'false' 12) #(23 'nil' 15) #(23 'true' 11)) do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/29/2004 11:35'!
createTokenFor: string 
	| token |
	token := CMParseToken
				id: matchActions
				whitespace: self flushWhitespace
				start: start
				value: string. 
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 5/30/2004 00:12'!
scan9
	self recordMatch: #(24).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
	^self reportLastMatch! !

TestCase subclass: #CMImporterTest
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 20:07'!
testMethodAnnotations
	| annotations method |
	method _ package classes first methods first.
	annotations _ method annotations.
	annotations do: [:ea | self assert: ea parent == method.
						ea selectorParts do: [:part | self assert: part isToken].
						ea arguments do: [:arg | self assert: arg isLiteral]].
	self assert: (annotations collect: [:ea | ea selector]) asArray = #(category: author: timestamp:).
	self shouldnt: [DateAndTime fromString: annotations third arguments first value]
		raise: Exception! !

!CMImporterTest methodsFor: 'running' stamp: 'cwp 5/20/2004 17:04'!
setUp
	package _ CMPackageImporter import: 'Bogus'! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 20:04'!
testClassVariables
	| cvars class |
	class _ package classes second.
	cvars _ class classVariables.
	self assert: cvars first name = #FirstClassVariableB.
	self assert: cvars second name = #SecondClassVariableB.
	self assert: cvars first parent == class.
	self assert: cvars second parent == class.! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 20:07'!
testInstanceMethods
	self 
		assertMethodsIn: package classes first
		match: BogusInfo instanceMethodsA! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:49'!
testPoolImports
	| pool class |
	class _ package classes second.
	pool _ class poolImports first.
	self assert: pool name = #BogusPool.
	self assert: pool parent == class.! !

!CMImporterTest methodsFor: 'asserting' stamp: 'cwp 5/31/2004 21:46'!
assertMethodsIn: class match: expected
	| methods |
	methods _ class methods.
	methods do: [:ea | 
				self assert: ea parent = class.
				self assert: ea isMethod].
	self assert: (methods collect: [:ea | ea selector]) asArray = expected
! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/27/2004 16:46'!
testInstanceVariables
	| ivars class |
	class _ package classes second.
	ivars _ class instanceVariables.
	self assert: ivars first name = #firstInstanceVariableB.
	self assert: ivars second name = #secondInstanceVariableB.
	self assert: ivars first parent == class.
	self assert: ivars second parent == class.! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 20:06'!
testClassMethods
	self 
		assertMethodsIn: package metaclasses first
		match: BogusInfo classMethodsA! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 6/1/2004 17:54'!
testClasses
	package classes 
				with: BogusInfo classes 
				do: [:node :class | 
					self assert: (node refersTo: class).
					self assert: node parent == package.
					self assert: node category = class category]
	! !

!CMImporterTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 19:42'!
testClassInstVariables
	| civars metaclass |
	metaclass _ package metaclasses second.
	civars _ metaclass instanceVariables.
	self assert: civars first name = #firstClassInstanceVariableB.
	self assert: civars second name = #secondClassInstanceVariableB.
	self assert: civars first parent == metaclass.
	self assert: civars second parent == metaclass! !

TestCase subclass: #CMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testLessThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 < 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #<.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBinarySymbolLiteral
	| root |
	root _ self parseExpression: '#+'.
	self assertLiteralExpression: root equals: #+! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testFalseLiteral
	self assertLiteralParses: false! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:04'!
testBinaryMethod
	| root |
	root _ self parseMethod: '+ other ^ other'.
	self assert: root isMethod.
	self assert: root selector = #+.
	self assert: root body isSequence.
	self assert: root body leftBar isNil.
	self assert: root body rightBar isNil.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseAnnotations: aString
	^ self parse: aString with: #parseAnnotations:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCharacterLiteral
	| root |
	root _ self parseExpression: '$g'.
	self assertLiteralExpression: root equals: $g! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testGreaterThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 > 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #>.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:21'!
testEmptyMethod
	| root |
	root _ self parseMethod: 'foo'.
	self assert: root isMethod.
	self assert: root selector = #foo! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:27'!
testMethodWithTempsAndAnnotation2
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> | foo bar |  ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:'.
	self assertLiteralExpression: root equals: #foo:! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 13:58'!
parse: aString with: aSelector
	| result |
	self 
		shouldnt: [result _ self parser perform: aSelector with: aString] 
		raise: SmaCCParserError.
	^ result! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseExpression: aString
	^ self parse: aString with: #parseExpression:! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/24/2004 14:38'!
assertLiteralExpression: root equals: value
	self assert: root isSequence.
	self assert: root statements first isLiteral.
	self assert: root statements first value = value
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testMultiKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:bar:'.
	self assertLiteralExpression: root equals: #foo:bar:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithArguments
	| root |
	root _ self parseExpression: '[:foo :bar | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first arguments 
						with: #(foo bar)
						do: [:arg :name | 
							self assert: arg isArgument.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testExpressionWithTemps
	| root |
	root _ self parseExpression: '| foo bar | foo _ 2. bar _ 3. foo + bar'.
	self assert: root isSequence.
	root temporaries with: #(foo bar) do: [:temp :name |
						self assert: (temp isVariableReference).
						self assert: (name = temp name)].
	self assert: root leftBar isToken.
	self assert: root leftBar value = '|'.
	self assert: root rightBar isToken.
	self assert: root rightBar value = '|'.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 15:32'!
testNestedArrayLiteral
	self assertLiteralParses: #(1 2 (3 4 5))! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:27'!
testUnaryMessage
	| root message |
	root _ self parseExpression: 'self foo'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #foo.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCascade2
	| root cascade |
	root _ self parseExpression: 'self foo; bar; baz'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testBareReturn
	| root |
	root _ self parseExpression: '^ 1'.
	self assert: root isSequence.
	self assert: root statements first isReturn.
	self assert: root statements first value isLiteral.
	self assert: root statements first value value = 1.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testAssignment
	| root |
	root _ self parseExpression: 'var _ #value'.
	self assert: root statements first isAssignment.
	self assert: root statements first variable isVariableReference.
	self assert: root statements first value isValue.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCascade
	| root cascade |
	root _ self parseExpression: 'self foo; bar'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:42'!
testNegativeNumberLiteral
	self assertLiteralParses: -13! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseMethod: aString
	^ self parse: aString with: #parseMethod:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/30/2004 00:05'!
testBlock
	| root |
	root _ self parseExpression: '[self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/29/2004 23:34'!
testMultiPrim2
	| prims |
	prims _ self parseAnnotations: '<primitive: 1><primitive: 2>'.
	self assert: prims first isAnnotation.
	self assert: prims second isAnnotation.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testArrayLiteral
	self assertLiteralParses: #(1 2 3)! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:28'!
testMethodWithSplitAnnotations
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> | foo bar | <primitive: 2> ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	self assert: root annotations second isAnnotation.
	self assert: root body leftBar isToken.
	self assert: root body rightBar isToken.
	self assert: root body isSequence.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testByteArrayLiteral
	| root |
	root _ self parseExpression: '#[1 2 3]'.
	self assertLiteralExpression: root equals: (ByteArray with: 1 with: 2 with: 3)! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:21'!
testArray
	| root |
	root _ self parseExpression: '{1. self foo. 2}'.
	self assert: root statements first isArray.
	self assert: root statements first statements first isLiteral.
	self assert: root statements first statements second isMessage.
	self assert: root statements first statements third isLiteral.! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:22'!
testKeywordMethod
	| root |
	root _ self parseMethod: 'foo: anObject bar: object ^ anObject + object'.
	self assert: root isMethod.
	self assert: root selector = #foo:bar:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testBinaryMessage
	| root message |
	root _ self parseExpression: '3 + 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #+.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/28/2004 06:26'!
testMultiPrim
	| prims |
	prims _ self parseAnnotations: '<primitive: 1> <primitive: 2>'.
	self assert: prims first isAnnotation.
	self assert: prims second isAnnotation.! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/28/2004 06:25'!
testMultiKeywordPrim
	| prim |
	prim _ (self parseAnnotations: '<primitive: ''foo'' module: ''FooModule''>') first.
	self assert: prim selector = #primitive:module:.
	self assert: (prim arguments collect: [:ea | ea value]) = #('foo' 'FooModule').
	self assert: prim isAnnotation! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testKeywordMessage
	| root message |
	root _ self parseExpression: 'self add: 4 to: 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #add:to:.
	self assert: message arguments first isLiteral.
	self assert: message arguments second isLiteral.! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:22'!
testUnaryMethod
	| root |
	root _ self parseMethod: 'foo ^ #foo'.
	self assert: root isMethod.
	self assert: root selector = #foo! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testReturnWithStatements
	| root |
	root _ self parseExpression: 'self foo. self bar. ^ 1'.
	self assert: root isSequence.
	self assert: root statements third isReturn.
	self assert: root statements third value isLiteral.
	self assert: root statements third value value = 1.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:42'!
testNumberLiteral
	self assertLiteralParses: 13! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodWithAnnotation
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> ^ super + aNumber'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	self assert: root annotations first selector = #primitive:.
	self assert: root annotations first arguments first isLiteral.
	self assert: root annotations first arguments first value = 1.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testStringLiteral
	| root |
	root _ self parseExpression: '''foo'''.
	self assertLiteralExpression: root equals: 'foo'! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testStringSymbolLiteral
	| root |
	root _ self parseExpression: '#''foo bar'''.
	self assertLiteralExpression: root equals: #'foo bar'! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/28/2004 06:22'!
assertLiteralParses: value
	| root |
	root _ self parseExpression: value asString.
	self assertLiteralExpression: root equals: value! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testTrueLiteral
	self assertLiteralParses: true! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testSymbolLiteral
	| root |
	root _ self parseExpression: '#foo'.
	self assertLiteralExpression: root equals: #foo! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps
	| root |
	root _ self parseExpression: '[:foo :bar | | baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testNilLiteral
	self assertLiteralParses: nil! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodWithTempsAndAnnotation
	| root |
	root _ self parseMethod: '+ aNumber | foo bar | <primitive: 1> ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:18'!
parser
	^ CMParser! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps2
	| root |
	root _ self parseExpression: '[:foo :bar || baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodEmptyTempsAndAnnotation
	| root |
	root _ self parseMethod: 'foo: aNumber || <primitive: 1> ^ foo'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

TestCase subclass: #CMPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testComment
	self assertMethodMatches: 'foo "this is a comment" ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:29'!
testBlockWithTemps
	self assertExpressionMatches: ' [:a : b :c || foo bar | foo]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:16'!
testArray
	self assertExpressionMatches: ' {foo. var. brz}'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 02:38'!
assertTree: root matches: source
	| stream result |
	stream _ WriteStream on: (String new: source size).
	CMSourcePrinter print: root on: stream.
	result _ stream contents.
	self assert: result = source.! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment1
	self assertExpressionMatches: 'foo _ bar'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/26/2004 15:15'!
assertAnnotationMatches: source
	| stream result |
	stream _ WriteStream on: (String new: source size).
	(CMParser parseAnnotations: source)
		do: [:ea | CMSourcePrinter print: ea on: stream].
	result _ stream contents.
	self assert: result = source.! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 15:31'!
testKeywordMethod
	self assertMethodMatches: 'foo: one bar: two ^ two'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:04'!
testLiteral
	self assertExpressionMatches: '''foo'''! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:29'!
assertMethodMatches: source
	self assertTree: (CMParser parseMethod: source) matches: source
! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment2
	self assertExpressionMatches: 'foo := bar'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:16'!
testMulitpleAnnotations
	self assertAnnotationMatches: '<primitive: 1> <primitive: 2>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:20'!
testUnaryMethod
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testByteArray
	self assertExpressionMatches: '#[10 13]'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:00'!
testPrimitive
	self assertAnnotationMatches: '<primitive: 1>'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:39'!
testBlock
	self assertExpressionMatches: ' [foo bar. baz]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:58'!
testCascade
	self assertExpressionMatches: 'foo bar; baz'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:29'!
testMessages
	self assertExpressionMatches: 'foo bar. blic razz: 3 zap: 4. zic + 2'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:53'!
testBlockArgs
	self assertExpressionMatches: ' [:a :b :c]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 19:35'!
testParenthesis3
	self assertExpressionMatches: '(foo _ 1) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:23'!
testReturn
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:30'!
assertExpressionMatches: source
	self assertTree: (CMParser parseExpression: source) matches: source
! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testTemps
	self assertMethodMatches: 'foo | glaz blech | ^ 1'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/29/2004 23:48'!
testAdjacentAnnotations
	self assertAnnotationMatches: '<primitive: 1><primitive: 2>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:21'!
testBinaryMethod
	self assertMethodMatches: '+ other ^ 1'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:12'!
testMultikeywordAnnotation
	self assertAnnotationMatches: '<primitive: ''foo'' module: ''bar''>'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:54'!
testParenthesis2
	self assertExpressionMatches: '([self doSomething] on: Error do: []) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 14:47'!
testBlockWithArgs
	self assertExpressionMatches: ' [:a :b :c | self so: a by: b see: c]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:33'!
testParenthesis
	self assertExpressionMatches: '(self foo: 1) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testLiteralArray
	self assertExpressionMatches: '#(foo bar 1 2)'! !

TestCase subclass: #CMPackageMirrorTest
	instanceVariableNames: 'info mirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageMirrorTest methodsFor: 'running' stamp: 'cwp 5/26/2004 16:33'!
setUp
	info _ PackageInfo hidden: 'Bogus'.
	mirror _ CMPackageMirror forInfo: info.
	! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:44'!
testCoreClasses
	self assert: mirror classes = info classes! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:37'!
testName
	self assert: mirror packageName = info packageName! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 19:46'!
testMethods
	| expected actual |
	expected _ info methods.
	actual _ mirror methods.
	self assert: actual size = expected size.
	self assert: (actual includesAllOf: expected)! !

PackageInfo subclass: #CMPackageMirror
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 5/26/2004 16:46'!
classes
	^ model classes collect: [:ea | Smalltalk at: ea name]! !

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 5/31/2004 21:50'!
methods
	| methods block |
	methods _ Set new.
	block _ [:class | class methods do: [:m | methods add: m asMethodReference]].
	model classes do: block.
	model metaclasses do: block.
	^ methods asArray! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:35'!
model: aPackageNode
	model _ aPackageNode! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:39'!
packageName
	^ model name! !

!CMPackageMirror class methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2004 16:38'!
forInfo: aPackageInfo
	^ self new model: (CMPackageImporter importFromPackageInfo: aPackageInfo)! !

Object subclass: #CMPackageImporter
	instanceVariableNames: 'package class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 6/1/2004 18:04'!
importClass: aClass
	class _ CMClass named: aClass name.
	class superName: aClass superclass name.
	class format: aClass typeOfClass.
	aClass instVarNames do: [:ea | self importInstVar: ea].
	aClass classVarNames asSortedCollection do: [:ea | self importClassVar: ea].
	aClass sharedPoolsString substrings do: [:ea | self importPoolImport: ea].
	self annotateClassWithCategory: aClass category.
	package addClass: class! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:39'!
importFromPackageInfo: aPackageInfo
	| importer |
	importer _ self new.
	^ importer importPackage: aPackageInfo.
	! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 6/1/2004 10:03'!
importMetaclass: aClass
	class _ CMMetaclass named: aClass theNonMetaClass name .
	aClass instVarNames do: [:ea | self importInstVar: ea].
	package addMetaclass: class! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:46'!
importClassInstVar: name
	class addClassInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:20'!
annotateMethod: method withDate: dateString andTime: timeString

	| date time timestamp |
	date _ dateString findTokens: $/.
	time _ timeString findTokens: $:.
	timestamp _ DateAndTime
					year: date third asNumber
					month: date first asNumber
					day: date second asNumber
					hour: time first asNumber
					minute: time second asNumber
					second: 0.
	
	method addAnnotation: (CMAnnotation 
								selector: #timestamp: 
								argument: (CMLiteral for: timestamp asString)).
					! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/31/2004 21:38'!
importMethod: ref
	| method category |
	method _ CMParser parseMethod: ((ref actualClass sourceCodeAt: ref methodSymbol) 
											asString withSqueakLineEndings).
	category _ ref actualClass organization categoryOfElement: ref methodSymbol.
	self annotateMethod: method withCategory: category.
	ref timeStamp = '' ifFalse: [self annotateMethod: method withTimestamp: ref timeStamp].
	
	class addMethod: method! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 17:00'!
import: aPackageName
	^ self importFromPackageInfo: (PackageInfo named: aPackageName)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/31/2004 21:40'!
importPackage: aPackageInfo
	package _ CMPackage named: aPackageInfo packageName.
	aPackageInfo classes do: [:ea | self importClass: ea.
							(aPackageInfo coreMethodsForClass: ea) 
								do: [:each| self importMethod: each].
							self importMetaclass: ea class.
							(aPackageInfo coreMethodsForClass: ea class) 
								do: [:each| self importMethod: each]].
	^ package! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 6/1/2004 18:04'!
annotateClassWithCategory: aSymbol
	class addAnnotation: (CMAnnotation 
							selector: #category: 
							argument: (CMLiteral for: aSymbol))! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package
	^package! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:17'!
annotateMethod: method withAuthor: aString

	method addAnnotation: (CMAnnotation 
								selector: #author: 
								argument: (CMLiteral for: aString))
! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package: anObject
	package := anObject! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:24'!
annotateMethod: method withCategory: aSymbol
	method addAnnotation: (CMAnnotation 
								selector: #category: 
								argument: (CMLiteral for: aSymbol))! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:48'!
importPoolImport: name
	class addPoolImport: (CMPoolImport named: name)! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:21'!
annotateMethod: method withTimestamp: aString
	| substrings |
	substrings _ aString substrings.
	
	self annotateMethod: method withAuthor: substrings first.
	self annotateMethod: method withDate: substrings second andTime: substrings third.
! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:44'!
importInstVar: name
	 class addInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:44'!
importClassVar: name
	class addClassVariable: (CMSharedVariable named: name)! !

Object subclass: #CMGuide
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitReturn: aNode
	visitor visitReturn: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitAssignment: aNode
	visitor visitAssignment: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:11'!
visitNode: aNode
	visitor visitNode: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:04'!
visitAnnotation: aNode
	visitor visitAnnotation: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSharedVariable: aNode
	visitor visitSharedVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:49'!
visitToken: aToken
	aToken ifNotNil: [visitor visitToken: aToken]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSequence: aNode
	visitor visitSequence: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:27'!
visitVariableReference: aNode
	visitor visitVariableReference: aNode! !

!CMGuide methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:47'!
visitor: aVisitor
	visitor _ aVisitor! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:25'!
visitMethod: aNode
	visitor visitMethod: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitInstanceVariable: aNode
	visitor visitInstanceVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitLiteral: aNode
	visitor visitLiteral: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/31/2004 21:55'!
visitMetaclass: aMetaclass
	visitor visitMetaclass: aMetaclass! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitCascade: aNode
	visitor visitCascade: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPoolImport: aNode
	visitor visitPoolImport: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitArray: aNode
	visitor visitArray: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: anArgument
	visitor visitArgument: anArgument! !

CMGuide subclass: #CMTokenGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:50'!
visitLiteral: literal
	self visitValue: literal in: [self visitToken: literal token]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:55'!
visitKeywordMessagePattern: pattern
	pattern selectorParts 
				with: pattern arguments
				do: [:part :arg | self visitToken: part. self visit: arg]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:52'!
visitBlock: node
	self visitValue: node
		in: [self visitToken: node leftBracket.
			node arguments do: [:ea | self visitArgument: ea].
			node bar ifNotNilDo: [:bar | self visitToken: bar].
			self visitSequence: node body.
			self visitToken: node rightBracket]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 15:48'!
visitValue: value in: aBlock
	self visitToken: value leftParen.
	aBlock value.
	self visitToken: value rightParen! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 19:34'!
visitAssignment: node
	self visitValue: node in: [self visit: node variable.
							self visitToken: node operator.
							self visit: node value]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:54'!
visitUnaryMessagePattern: pattern
	self visitToken: pattern selectorParts first! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 12:18'!
visitStatements: statements andPeriods: periods
	periods ifNil: [statements do: [:ea | self visit: ea] separatedBy: [visitor visitToken: self period]. 
					^ self].
			
	1 to: periods size do: [:i | 
						self visit: (statements at: i).
						self visitToken: (periods at: i)].
	statements size > periods size ifTrue: [self visit: statements last]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 14:55'!
visitBinaryMessagePattern: pattern
	self visitToken: pattern selectorParts first.
	self visit: pattern arguments first! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:53'!
visitMessage: message
	self visitValue: message
		in: [self visit: message receiver.
			self visitMessageParts: message selectorParts andArguments: message arguments]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 13:23'!
visitArray: node
	self visitToken: node leftBrace.
	self visitStatements: node statements andPeriods: node periods.
	self visitToken: node rightBrace! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 12:30'!
visitMethod: method
	self visitMessagePattern: method.
	method annotations do: [:ea | self visitAnnotation: ea].
	self visitSequence: method body.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:43'!
visitArgument: node
	node colon ifNotNilDo: [:colon | self visitToken: colon].
	self visitToken: node identifier.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 12:09'!
visitSequence: sequence
	sequence leftBar ifNotNilDo: [:bar | self visitToken: bar].
	sequence temporaries ifNotNilDo: [:temps | temps do: [:ea | self visitVariableReference: ea]].
	sequence rightBar ifNotNilDo: [:bar | self visitToken: bar].
	self visitStatements: sequence statements andPeriods: sequence periods.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:06'!
visitAnnotation: aNode
	self visitValue: aNode in: [self visitMessagePattern: aNode]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 16:58'!
visitCascade: cascade
	self visit: cascade messages first.
	1 	to: cascade semicolons size 
		do: [:i | | semicolon message |
			semicolon _ (cascade semicolons at: i).
			message _ (cascade messages at: i + 1).
			self visitToken: semicolon.
			self visitMessageParts: message selectorParts andArguments: message arguments]! !

!CMTokenGuide methodsFor: 'private' stamp: 'cwp 5/26/2004 12:28'!
visitMessagePattern: messagePattern
	messagePattern isUnary ifTrue: [^ self visitUnaryMessagePattern: messagePattern].
	messagePattern isBinary ifTrue: [^ self visitBinaryMessagePattern: messagePattern].
	messagePattern isKeyword ifTrue: [^ self visitKeywordMessagePattern: messagePattern]! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 02:11'!
visitReturn: node
	self visitToken: node return.
	self visit: node value.! !

!CMTokenGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:46'!
visitVariableReference: node
	self visitValue: node in: [self visitToken: node identifier].! !

!CMGuide class methodsFor: 'guiding' stamp: 'cwp 5/25/2004 01:01'!
guide: aVisitor through: aNode
	| guide |
	guide _ self new.
	guide visitor: aVisitor.
	guide visit: aNode! !

!CMGuide methodsFor: 'guiding' stamp: 'cwp 5/25/2004 00:49'!
visit: aNode
	aNode acceptGuide: self! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPackage: aNode
	visitor visitPackage: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitBlock: aNode
	visitor visitBlock: aNode! !

!CMGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 02:37'!
visitMessageParts: parts andArguments: arguments
	parts size = 1
		ifTrue: [self visitToken: parts first.
				arguments isEmpty not ifTrue: [self visit: arguments first]]
		ifFalse: [parts with: arguments do: [:keyword :arg | 
											self visitToken: keyword. 
											self visit: arg]]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:24'!
visitMessage: aNode
	visitor visitMessage: aNode! !

Object subclass: #CMToken
	instanceVariableNames: 'whitespace value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMToken methodsFor: 'testing' stamp: 'cwp 5/25/2004 01:57'!
isToken
	^ true! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
value
	^ value! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 5/30/2004 00:30'!
whitespace: aString value: anObject 
	^ self new whitespace: aString value: anObject! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
whitespace
	^ whitespace! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:39'!
whitespace: aString
	whitespace _ aString! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 11:50'!
value: aString
	^ self whitespace: ' ' value: aString! !

CMToken subclass: #CMParseToken
	instanceVariableNames: 'start id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/30/2004 00:31'!
withValue: aString
	^ self class id: id whitespace: whitespace start: start value: aString! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/29/2004 23:40'!
secondChar
	^ self class id: id whitespace: '' start: start + 1 value: (value second asString)! !

!CMParseToken class methodsFor: 'as yet unclassified' stamp: 'cwp 5/30/2004 00:33'!
id: id whitespace: whitespace start: start value: value
	^ self new id: id whitespace: whitespace start: start value: value! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/30/2004 00:36'!
asTreeToken
	^ CMToken whitespace: whitespace value: value! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/28/2004 15:12'!
start: anInteger
	start _ anInteger! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/30/2004 00:25'!
id
	^ id! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:36'!
startPosition
	^ self start! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/29/2004 23:40'!
firstChar
	^ self withValue: value first asString! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:37'!
start
	^ start! !

!CMParseToken methodsFor: 'initializing' stamp: 'cwp 5/30/2004 00:28'!
id: anInteger whitespace: aString start: anInteger3 value: anObject 
	id _ anInteger.
	whitespace _ aString.
	start _ anInteger3.
	value _ anObject.
! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/30/2004 00:19'!
stopPosition
	^ start + value size! !

!CMToken methodsFor: 'printing' stamp: 'cwp 5/24/2004 21:23'!
printOn: aStream
	aStream nextPutAll: 'CMToken<'.
	self value printOn: aStream.
	aStream nextPut: $>.! !

!CMToken methodsFor: 'visiting' stamp: 'cwp 5/31/2004 12:02'!
acceptGuide: aGuide
	aGuide visitToken: self! !

!CMToken methodsFor: 'initializing' stamp: 'cwp 5/30/2004 00:32'!
whitespace: aString1 value: aString2
	whitespace _ aString1.
	value _ aString2.! !

Object subclass: #CMNode
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 13:20'!
isMethod
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/14/2004 23:55'!
isClass
	^ false! !

CMNode subclass: #CMPackage
	instanceVariableNames: 'name classes metaclasses globals pools initializer initializationSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/14/2004 01:02'!
name: aString 
	name _ aString! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer
	^ initializer! !

!CMPackage class methodsFor: 'instance creation' stamp: 'cwp 5/20/2004 17:07'!
named: aSymbol
	^ self new name: aSymbol! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence
	^ initializationSequence! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:54'!
removePool: aPoolNode
	pools ifNil: [^ nil].
	^ pools remove: aPoolNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
addPool: aPoolNode
	pools ifNil: [pools _ OrderedCollection new].
	pools add: aPoolNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:52'!
removeGlobal: aGlobalNode
	globals ifNil: [^ nil].
	^ globals remove: aGlobalNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPackage: self! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
addGlobal: aGlobalNode
	globals ifNil: [globals _ OrderedCollection new].
	globals add: aGlobalNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
globals
	^ globals ifNil: [#()]! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:50'!
removeClass: aClassNode
	classes ifNil: [^ nil].
	^ classes remove: aClassNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/31/2004 21:34'!
metaclasses
	^ metaclasses ifNil: [#()]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:56'!
hasInitializer
	^ initializer notNil! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/31/2004 21:35'!
removeMetaclass: aMetaclassNode
	metaclasses ifNil: [^ nil].
	^ metaclasses remove: aMetaclassNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
hasInitializationSequence
	^ initializationSequence notNil! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:46'!
classes
	^ classes ifNil: [#()]! !

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/16/2004 20:29'!
name
	^ name! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
pools
	^ pools ifNil: [#()]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence: anInitializationSequenceNode
	initializationSequence _ anInitializationSequenceNode! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 19:25'!
addClass: aClassNode
	classes ifNil: [classes _ OrderedCollection new].
	classes add: aClassNode.
	aClassNode parent: self! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/31/2004 21:34'!
addMetaclass: aMetaclassNode
	metaclasses ifNil: [metaclasses _ OrderedCollection new].
	metaclasses add: aMetaclassNode.
	aMetaclassNode parent: self! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer: anInitializerNode
	initializer _ anInitializerNode! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:49'!
isReturn
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/31/2004 21:54'!
isMetaclass
	^ false! !

!CMNode methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:58'!
acceptGuide: aGuide
	aGuide visitNode: self! !

CMNode subclass: #CMArgument
	instanceVariableNames: 'colon identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2004 14:22'!
identifier: aToken
	^ self colon: nil identifier: aToken! !

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2004 14:21'!
colon: colonToken identifier: idToken
	^ self new
		colon: colonToken;
		identifier: idToken! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
identifier
	^identifier! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:20'!
name
	^ self identifier value! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
identifier: anObject
	identifier := anObject! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
colon
	^colon! !

!CMArgument methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:22'!
acceptGuide: aGuide
	aGuide visitArgument: self! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
colon: anObject
	colon := anObject! !

!CMArgument methodsFor: 'testing' stamp: 'cwp 5/25/2004 14:40'!
isArgument
	^ true! !

CMNode subclass: #CMBehavior
	instanceVariableNames: 'name iVars methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBehavior class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 21:41'!
named: aSymbol 
	^ self new name: aSymbol! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 21:44'!
addMethod: aMethod 
	methods ifNil: [methods _ SortedCollection new].
	methods add: aMethod.
	aMethod parent: self.! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 20:53'!
name: aToken
	name _ aToken! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 20:59'!
addInstanceVariable: anInstanceVariable 
	iVars ifNil: [iVars _ OrderedCollection new].
	iVars add: anInstanceVariable.
	anInstanceVariable parent: self.! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 21:01'!
removeMethod: aMethod
	methods ifNil: [^ nil].
	^ (methods remove: aMethod ifAbsent: [^ nil]) parent: nil.! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 21:58'!
methods
	^ methods ifNil: [#()]! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 20:59'!
removeInstanceVariable: anInstanceVariableNode
	iVars ifNil: [^ nil].
	^ (iVars remove: anInstanceVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 20:53'!
name
	^ name! !

CMBehavior subclass: #CMMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMetaclass methodsFor: 'testing' stamp: 'cwp 5/31/2004 21:53'!
isMetaclass
	^ true! !

!CMMetaclass methodsFor: 'visiting' stamp: 'cwp 5/31/2004 21:54'!
acceptGuide: aGuide
	aGuide visitMetaclass: self! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 5/31/2004 20:59'!
instanceVariables
	^ iVars ifNil: [#()]! !

CMBehavior subclass: #CMClass
	instanceVariableNames: 'superName format cVars imports initialize annotations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMClass methodsFor: 'convenience' stamp: 'cwp 6/1/2004 18:01'!
category
	^ (self annotations 
		detect: [:ann | ann selector = #category:]
		ifNone: [^ '']) argument value! !

!CMClass methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitClass: self! !

!CMClass methodsFor: 'annotations' stamp: 'cwp 6/1/2004 17:59'!
annotations
	^ annotations ifNil: [#()]! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:40'!
removePoolImport: aPoolImportNode
	imports ifNil: [^ #()].
	^ (imports remove: aPoolImportNode ifAbsent: [^ nil]) parent: nil.! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:35'!
poolImports
	^ imports ifNil: [^ #()]! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 17:12'!
classVariables
	^ cVars ifNil: [#()]! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 17:11'!
name: aNameNode
	name _ aNameNode! !

!CMClass methodsFor: 'annotations' stamp: 'cwp 6/1/2004 17:59'!
removeAnnotation: anAnnotation
	annotations ifNil: [^ nil].
	^ (annotations remove: anAnnotation ifAbsent: [^ nil]) parent: nil.! !

!CMClass methodsFor: 'annotations' stamp: 'cwp 6/1/2004 17:59'!
addAnnotation: anAnnotation
	annotations ifNil: [annotations _ OrderedCollection new].
	annotations add: anAnnotation.
	anAnnotation parent: self.! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 19:29'!
addClassVariable: aClassVariableNode
	cVars ifNil: [cVars _ OrderedCollection new].
	cVars add: aClassVariableNode.
	aClassVariableNode parent: self.! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/15/2004 00:59'!
isClass
	^ true! !

!CMClass methodsFor: 'pool imports' stamp: 'cwp 5/20/2004 21:38'!
addPoolImport: aPoolImportNode
	imports ifNil: [imports _ OrderedCollection new].
	imports add: aPoolImportNode.
	aPoolImportNode parent: self.! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName: aNameNode
	superName _ aNameNode! !

!CMClass methodsFor: 'class variables' stamp: 'cwp 5/20/2004 19:30'!
removeClassVariable: aClassVariableNode
	cVars ifNil: [^ nil].
	^ (cVars remove: aClassVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:44'!
hasSuperName
	^ superName notNil! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/15/2004 00:49'!
name
	^ name! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format
	^ format! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format: anInstanceStateNode 
	format := anInstanceStateNode! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName
	^ superName! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/20/2004 19:16'!
refersTo: anObject
	anObject isBehavior ifFalse: [^ false].
	name = anObject name ifFalse: [^ false].
	superName = anObject superclass name ifFalse: [^ false].
	format = anObject typeOfClass ifFalse: [^ false]. 
	^ true! !

CMNode subclass: #CMMethod
	instanceVariableNames: 'selectorParts arguments annotations body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:59'!
isBinary
	^ self selector isInfix! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/31/2004 11:43'!
addAnnotation: anAnnotation
	annotations add: anAnnotation.
	anAnnotation parent: self! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:08'!
body
	^body! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
arguments
	^arguments! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
selectorParts
	^selectorParts! !

!CMMethod methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:58'!
acceptGuide: aGuide
	aGuide visitMethod: self! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 14:58'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/24/2004 13:20'!
isMethod
	^ true! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations
	^annotations! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:09'!
selectorParts: aCollection arguments: aCollection2
	selectorParts := aCollection.
	arguments := aCollection2! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:57'!
isUnary
	^ self selector isUnary! !

!CMMethod methodsFor: 'comparing' stamp: 'cwp 5/31/2004 21:43'!
<= other
	^ self selector <= other selector! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations: anObject
	annotations := anObject! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/25/2004 23:07'!
name
	^ self selector! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:08'!
body: anObject
	body := anObject! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:58'!
isKeyword
	^ self selector isKeyword! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:08'!
selectorParts: parts arguments: args annotations: annotations body: sequence
	^ self new
			selectorParts: parts arguments: args;
			annotations: annotations;
			body: sequence! !

!CMMethod methodsFor: 'converting' stamp: 'cwp 6/1/2004 09:59'!
asMethodReference
	| ref |
	ref _ MethodReference new.
	ref 
		setClassSymbol: self parent name 
		classIsMeta: (parent isMetaclass)
		methodSymbol: self selector
		stringVersion: ''.
	^ ref! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:09'!
selectorParts: parts arguments: args body: sequence
	^ self selectorParts: parts arguments: args annotations: OrderedCollection new body: sequence! !

CMNode subclass: #CMReturn
	instanceVariableNames: 'return value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMReturn class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 02:05'!
return: aToken value: aValueNode
	^ self new return: aToken value: aValueNode! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/24/2004 15:39'!
value
	^ value! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/25/2004 02:08'!
return
	^ return! !

!CMReturn methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:48'!
isReturn
	^ true! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/25/2004 02:04'!
return: aToken value: aValueNode
	return := aToken.
	value := aValueNode! !

!CMReturn methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitReturn: self! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 17:21'!
isBlock
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:59'!
isCascade
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/25/2004 01:56'!
isToken
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/26/2004 10:54'!
isAnnotation
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/25/2004 14:31'!
isArgument
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/16/2004 22:22'!
parent: aNode
	parent _ aNode! !

CMNode subclass: #CMValue
	instanceVariableNames: 'leftParen rightParen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:37'!
leftParen: left rightParen: right
	leftParen := left.
	rightParen := right! !

CMValue subclass: #CMBlock
	instanceVariableNames: 'arguments body leftBracket bar rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:49'!
bar
	^bar! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 17:19'!
arguments: anArray body: aSequence 
	^ self new arguments: anArray; body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
arguments
	^arguments! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:51'!
leftBracket: left rightBracket: right
	leftBracket _ left.
	rightBracket _ right! !

!CMBlock methodsFor: 'testing' stamp: 'cwp 5/24/2004 17:21'!
isBlock	
	^ true! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
leftBracket
	^ leftBracket! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
body: anObject
	body := anObject! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:49'!
bar: anObject
	bar := anObject! !

!CMBlock methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitBlock: self! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
body
	^body! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 14:02'!
body: aSequence
	^ self arguments: #() body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
arguments: anObject
	arguments := anObject! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
rightBracket
	^ rightBracket! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:36'!
leftParen
	^leftParen! !

!CMValue methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:22'!
isValue
	^ true! !

CMValue subclass: #CMLiteral
	instanceVariableNames: 'token value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
token
	^token! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
value: anObject
	value := anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:42'!
value
	^value! !

!CMLiteral class methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2004 12:24'!
for: anObject
	^ self token: (CMToken value: anObject printString) value: anObject! !

!CMLiteral class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 13:42'!
token: aToken value: anObject
	^ self new token: aToken; value: anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
token: anObject
	token := anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:33'!
name
	^ self token value! !

!CMLiteral methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitLiteral: self! !

!CMLiteral methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:43'!
isLiteral
	^ true! !

CMValue subclass: #CMAssignment
	instanceVariableNames: 'variable operator value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
variable
	^variable! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
value: anObject
	value := anObject! !

!CMAssignment class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 19:33'!
variable: aVariableReference operator: aToken value: aValue
	^ self new 
		variable: aVariableReference; 
		operator: aToken;
		value: aValue! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
value
	^value! !

!CMAssignment methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:25'!
isAssignment
	^ true! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/25/2004 19:31'!
operator
	^operator! !

!CMAssignment methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitAssignment: self! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/25/2004 19:31'!
operator: anObject
	operator := anObject! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
variable: anObject
	variable := anObject! !

CMValue subclass: #CMMessagePattern
	instanceVariableNames: 'selectorParts arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

CMMessagePattern subclass: #CMMessage
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMessage methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:35'!
receiver: anObject
	receiver := anObject! !

!CMMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 18:39'!
receiver: receiver selectorParts: parts arguments: args
	^ self new
			receiver: receiver;
			selectorParts: parts;
			arguments: args! !

!CMMessage methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:35'!
receiver
	^receiver! !

!CMMessage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitMessage: self! !

!CMMessage methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:47'!
isMessage
	^ true! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isUnary
	^ self selector isUnary! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 6/1/2004 18:06'!
argument
	^ self arguments first! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 12:32'!
selector: aSelector arguments: aSequenceableCollection
	| keywords parts |
	keywords _ aSelector keywords.
	parts _ Array new: keywords size.
	parts at: 1 put: (CMToken whitespace: '' value: keywords first).
	2 to: keywords size do: [:i | parts at: i put: (CMToken value: (keywords at: i))].
	^ self 
		selectorParts: parts
		arguments: aSequenceableCollection! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:53'!
arguments
	^arguments! !

CMMessagePattern subclass: #CMAnnotation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAnnotation methodsFor: 'testing' stamp: 'cwp 5/26/2004 10:54'!
isAnnotation
	^ true! !

!CMAnnotation methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
acceptGuide: aGuide
	aGuide visitAnnotation: self! !

!CMAnnotation class methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2004 12:07'!
selector: selector arguments: args
	^ (super selector: selector arguments: args)
		leftParen: (CMToken whitespace: '
	' value: '<')
		rightParen: (CMToken whitespace: '' value: '>')! !

!CMAnnotation methodsFor: 'printing' stamp: 'cwp 5/31/2004 10:32'!
name
	^ self selector! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:52'!
selectorParts: anObject
	selectorParts := anObject! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:53'!
arguments: anObject
	arguments := anObject! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:52'!
selectorParts
	^selectorParts! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:00'!
selectorParts: parts arguments: args
	^ self new
			selectorParts: parts;
			arguments: args! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 15:06'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isKeyword
	^ self selector isKeyword! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 15:06'!
isBinary
	^ self selector isInfix! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 11:39'!
selector: aSelector argument: anObject
	^ self selector: aSelector arguments: (Array with: anObject)! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:37'!
rightParen
	^ rightParen! !

CMValue subclass: #CMCascade
	instanceVariableNames: 'messages semicolons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMCascade methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitCascade: self! !

!CMCascade methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:59'!
isCascade
	^ true! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:23'!
addMessage: aMessage semicolon: aToken
	messages add: aMessage.
	semicolons add: aToken! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:58'!
messages
	^ messages! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:30'!
firstMessage: aMessage
	messages _ OrderedCollection with: aMessage.
	semicolons _ OrderedCollection new.! !

!CMCascade class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 16:31'!
message: aMessage
	^ self new firstMessage: aMessage! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:17'!
semicolons
	^semicolons! !

CMValue subclass: #CMVariableReference
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariableReference methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:01'!
acceptGuide: aGuide
	aGuide visitVariableReference: self! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:03'!
identifier
	^ identifier! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:03'!
identifier: aToken
	identifier := aToken! !

!CMVariableReference methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:04'!
isVariableReference
	^ true! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:06'!
name
	^ self identifier value! !

!CMNode methodsFor: 'printing' stamp: 'cwp 5/15/2004 01:23'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $<.
	aStream nextPutAll: self name.
	aStream nextPut: $>! !

!CMNode methodsFor: 'printing' stamp: 'cwp 5/16/2004 20:28'!
name
	^ ''! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 19:08'!
isArray
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:23'!
isValue
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/16/2004 20:12'!
isClassVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:04'!
isVariableReference
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:25'!
isAssignment
	^ false! !

CMNode subclass: #CMStatementList
	instanceVariableNames: 'statements periods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
periods
	^periods! !

!CMStatementList class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:29'!
statements: statements periods: periods
	^ self new statements: statements periods: periods! !

CMStatementList subclass: #CMArray
	instanceVariableNames: 'leftBrace rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArray methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitArray: self! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
rightBrace
	^rightBrace! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:21'!
leftBrace: left rightBrace: right
	leftBrace := left.
	rightBrace := right! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
leftBrace
	^leftBrace! !

!CMArray class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 19:07'!
statements: anArray
	^ self new statements: anArray! !

!CMArray methodsFor: 'testing' stamp: 'cwp 5/24/2004 19:08'!
isArray
	^ true! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:28'!
statements: aCollection1 periods: aCollection2 
	statements := aCollection1.
	periods := aCollection2.! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
statements
	^statements! !

CMStatementList subclass: #CMSequence
	instanceVariableNames: 'leftBar temporaries rightBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSequence methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:32'!
isSequence
	^ true! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:31'!
temporaries: temps statements: statements
	^ self new temporaries: temps statements: statements! !

!CMSequence methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSequence: self! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
rightBar
	^rightBar! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:53'!
leftBar: left rightBar: right
	leftBar := left.
	rightBar := right! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:53'!
temporaries: temps statements: statements periods: periods
	^ (self statements: statements periods: periods) temporaries: temps! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 14:31'!
statements: statements
	^ self new statements: statements! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:35'!
temporaries
	^ temporaries! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
leftBar
	^leftBar! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:35'!
temporaries: anObject
	temporaries := anObject! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:47'!
isMessage
	^ false! !

CMNode subclass: #CMVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariable class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 22:48'!
named: aSymbol
	^ self new name: aSymbol! !

CMVariable subclass: #CMInstanceVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMInstanceVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitInstanceVariable: self! !

!CMInstanceVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 20:05'!
isInstanceVariable
	^ true! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:42'!
name
	^ name! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:49'!
name: aSymbol
	name _ aSymbol! !

CMVariable subclass: #CMSharedVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSharedVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 22:23'!
isClassVariable
	^ parent isClass! !

!CMSharedVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSharedVariable: self! !

CMVariable subclass: #CMPoolImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPoolImport methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPoolImport: self! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/15/2004 22:55'!
isInstanceVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:32'!
isSequence
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/20/2004 19:24'!
parent
	^ parent! !

Object subclass: #CMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitClass: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:10'!
visitToken: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitSharedVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitBlock: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitReturn: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
visitAnnotation: aNode
	self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitInstanceVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMessage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitCascade: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPoolImport: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitLiteral: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:27'!
visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMethod: aNode
	^ self visitNode: aNode! !

CMVisitor subclass: #CMSourcePrinter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMSourcePrinter class methodsFor: 'printing' stamp: 'cwp 5/31/2004 12:04'!
print: aNode
	| stream |
	stream _ WriteStream on: (String new: 100).
	self print: aNode on: stream.
	^ stream contents! !

!CMSourcePrinter class methodsFor: 'printing' stamp: 'cwp 5/25/2004 00:34'!
print: aNode on: aStream
	| printer |
	printer _ self new.
	printer stream: aStream.
	printer print: aNode! !

!CMSourcePrinter methodsFor: 'printing' stamp: 'cwp 5/25/2004 02:13'!
print: aNode 
	CMTokenGuide guide: self through: aNode.
! !

!CMSourcePrinter methodsFor: 'visiting' stamp: 'cwp 5/25/2004 02:14'!
visitToken: aToken
	stream nextPutAll: aToken whitespace.
	stream nextPutAll: aToken value! !

!CMSourcePrinter methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:35'!
stream: aStream
	stream _ aStream! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitVariableReference: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitArray: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPackage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitAssignment: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitSequence: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/31/2004 21:55'!
visitMetaclass: aMetaclass
	self visitNode: aMetaclass! !
